require 'payler_api/response'
require 'payler_api/request'

module PaylerAPI
  AvailableMethods = [:pay, :block, :charge, :retrieve, :refund, :repeat_pay, :get_template, 
                      :activate_template,  :get_status, :get_advanced_status, :send_3ds, :customer_register]

  def self.method_missing(method, *arguments, &block)
    return super unless AvailableMethods.include? method

    PaylerAPI::Request.new(method, *arguments).process
  end

  # self.configure method
  #   for setup :access_key
  class << self
    attr_accessor :configuration

    def configuration
      @configuration ||= Configuration.new
    end

    def configure
      yield(configuration)
    end
  end

  class Configuration
    attr_accessor :access_key, :host, :password

    def initialize
      @access_key, @host, @password = ['']*3
    end
  end
end
